Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts2.components
Class IteratorComponent

    java.lang.Object
      org.apache.struts2.components.Component
          org.apache.struts2.components.IteratorComponent

    public class IteratorComponent

extends Component

Iterator will iterate over a value. An iterable value can be either of: java.util.Collection, java.util.Iterator, java.util.Enumeration, java.util.Map, array.

- status (String) - if specified, an instanceof IteratorStatus will be pushed into stack upon each iteration
- value (Object) - the source to iterate over, must be iteratable, else an the object itself will be put into a newly created List (see MakeIterator#convert(Object)
- id (String) - if specified the current iteration object will be place with this id in Struts stack's context scope

The following example retrieves the value of the getDays() method of the current object on the value stack and uses it to iterate over. The <s:property/> tag prints out the current value of the iterator.

     <s:iterator value="days">
       <p>day is: <s:property/></p>
     </s:iterator>

The following example uses a `Bean` tag and places it into the ActionContext. The iterator tag will retrieve that object from the ActionContext and then calls its getDays() method as above. The status attribute is also used to create a `IteratorStatus` object, which in this example, its odd() method is used to alternate row colours:

     <s:bean name="org.apache.struts2.example.IteratorExample" id="it">
       <s:param name="day" value="'foo'"/>
       <s:param name="day" value="'bar'"/>
     </s:bean>

     <table border="0" cellspacing="0" cellpadding="1">
     <tr>
       <th>Days of the week</th>
     </tr>

     <s:iterator value="#it.days" status="rowstatus">
       <tr>
         <s:if test="#rowstatus.odd == true">
           <td style="background: grey"><s:property/></td>
         </s:if>
         <s:else>
           <td><s:property/></td>
         </s:else>
       </tr>
     </s:iterator>
     </table>

The next example will further demonstrate the use of the status attribute, using a DAO obtained from the action class through OGNL, iterating over groups and their users (in a security context). The last() method indicates if the current object is the last available in the iteration, and if not, we need to seperate the users using a comma:

      <s:iterator value="groupDao.groups" status="groupStatus">
          <tr class="<s:if test="#groupStatus.odd == true ">odd</s:if><s:else>even</s:else>">
              <td><s:property value="name" /></td>
              <td><s:property value="description" /></td>
              <td>
                  <s:iterator value="users" status="userStatus">
                      <s:property value="fullName" /><s:if test="!#userStatus.last">,</s:if>
                  </s:iterator>
              </td>
          </tr>
      </s:iterator>

The next example iterates over a an action collection and passes every iterator value to another action. The trick here lies in the use of the '[0]' operator. It takes the current iterator value and passes it on to the edit action. Using the '[0]' operator has the same effect as using >s:property />. (The latter, however, does not work from inside the param tag).

          <s:action name="entries" id="entries"/>
          <s:iterator value="#entries.entries" >
              <s:property value="name" />
              <s:property />
              <s:push value="...">
                  <s:action name="edit" id="edit" >
                      <s:param name="entry" value="[0]" />
                  </s:action>
              </push>
          </s:iterator>

To simulate a simple loop with iterator tag, the following could be done. It does the loop 5 times.

     <s:iterator status="stat" value="{1,2,3,4,5}" >
        <!-- grab the index (start with 0 ... ) -->
        <s:property value="#stat.index" />

        <!-- grab the top of the stack which should be the -->
        <!-- current iteration value (0, 1, ... 5) -->
        <s:property value="top" />
     </s:iterator>

Field Summary
`protected Iterator` | `iterator`
`protected Object` | `oldStatus`
`protected IteratorStatus` | `status`
`protected String` | `statusAttr`
`protected IteratorStatus.StatusState` | `statusState`
`protected String` | `value`

Fields inherited from class org.apache.struts2.components.Component
`actionMapper, COMPONENT_STACK, id, parameters, stack`

Constructor Summary
`IteratorComponent(ValueStack stack)`

Method Summary
`boolean` | `end(Writer writer, String body)` Callback for the end tag of this component.
`void` | `setStatus(String status)`
`void` | `setValue(String value)`
`boolean` | `start(Writer writer)` Callback for the start tag of this component.

Methods inherited from class org.apache.struts2.components.Component
`addAllParameters, addParameter, altSyntax, copyParams, determineActionURL, determineNamespace, end, fieldError, findAncestor, findString, findString, findValue, findValue, findValue, getComponentStack, getId, getParameters, getStack, popComponentStack, setActionMapper, setId, toString, usesBody`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### iterator

    protected Iterator iterator

### status

    protected IteratorStatus status

### oldStatus

    protected Object oldStatus

### statusState

    protected IteratorStatus.StatusState statusState

### statusAttr

    protected String statusAttr

### value

    protected String value

Constructor Detail

### IteratorComponent

    public IteratorComponent(ValueStack stack)

Method Detail

### start

    public boolean start(Writer writer)

  Description copied from class: `Component`
  Callback for the start tag of this component. Should the body be evaluated?

  Overrides:
    `start` in class `Component`
  Parameters:
    `writer` - the output writer.
  Returns:
    true if the body should be evaluated

### end

    public boolean end(Writer writer,
                       String body)

  Description copied from class: `Component`
  Callback for the end tag of this component. Should the body be evaluated again?

  NOTE: will pop component stack.

  Overrides:
    `end` in class `Component`
  Parameters:
    `writer` - the output writer.
    `body` - the rendered body.
  Returns:
    true if the body should be evaluated again

### setStatus

    public void setStatus(String status)

### setValue

    public void setValue(String value)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 Apache Software Foundation. All Rights Reserved.